# scopes.py

`scopes.py` is a script that takes ibnetdiscover utility output and generates 'full' scope_info file (i.e. file containing all compute nodes).
The only required argument is a filename containing ibnetdiscover output (or - to use stdin).
`-f` switch sets filename fo the full scope_info file (or print to stdout if omitted).

scope_info file will contain one scope for every TOR switch (which is a switch having at least 4 nodes connected) and all nodes connected to that switch
will be in that scope.

if `-d <filename>` switch is given, additional file will be created. That file will contain distances (in number of links) between all pairs of TOR switches.
WARNING! Calculating distances may be long (tens of minutes) for large networks.

# run_scopes.sh

`run_scopes.sh` is a wrapper script around `scopes.py`. It accepts the same cli arguments as `scopes.py`. Additionally it may accept `-i <args>` switch instead of
ibnetdiscover output filename. In this case it runs ibnetdiscover with the given args and passes its output to the `scopes.py` script.

# cut_scopes.py

`cut_scopes.py` takes one required argument -- filename of 'full' scope_info file prepared with [`scopes.py`](#scopespy) script. If run inside SLURM job
or allocation, it takes nodename in that allocation, or you can supply second argument -- filename with a list of nodes, one per line, which are to be used to run
bisection_bw test.
ls -ltr
The script will create new scope_info file (using filename supplied via `-o` switch or stdout), containing only the nodes from current
allocation (or from supplied file). All the scopes left in output scope_info file will contain equal number of nodes. This scope_info file
can be used as an argument to `-S` switch to clusterkit to run bisection_bw test in current allocation.
